/*
**	low use items that can be eliminated to save instruction
**	space memory
*/
/**/
#define		printit(x)(x = x ? clist(NULL) : 0)
/**/
/*
	10,09,85:   rewrite of parsing
	10,05,85:   sub function corrections
	10,05,85:   hint function
	10,04,85:   independent undo for edcd
	10,04,85:   doshell correction
*/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include	"kedfuncs.h"
#include	"keyproto.h"
#include    <signal.h>
#include    <setjmp.h>
#define     GOOD        1
#define     BAD         0
#define     QUIT        0
#define     STOP        -1
#define     LOOP        1
#define     NACTS       64
/*
*/
/*
	compiler/loader gives no diagnostic when globally defined
	variable name (bfp) conflicts with local
	static      FILE    *bfp;
*/
/**/
/*EXTERN*/
extern	void	ignore();
extern	void	cterror();
extern	int		edoshell();
extern	jmp_buf	here;
extern	KARD	*kd;
/**/
/*STATIC*/
static		char	**kdo;
static		char	**kdt;
static		NOSIGN	del;		/* local del */
static		NOSIGN	prtype;		/* print type */
static		NOSIGN	prnumb;		/* numbering flag */
static		NOSIGN	enom;		/* no match message */
static      char    *xp[4];
static		char	*lx;		/* last command for error msgs */
static		FUNCP	sigint;
static		FUNCP	sigbrk;
static		FUNCP	sigfub;
/*
*/
#define     BUFSML      BLKSIZ
/*
*/
static	char	*elc;		/* last command sequence */
static  NOSIGN	_undo    =   YES;
static  int  	act[NACTS];
static  char    *nco    =   "<no core> '%s'\n";
static  char    *bcd    =   "<bad command> [%s]\n";
static  char    *tma    =   "<too many addresses> '%s'\n";
static  char    *nad    =   "<bad address> '%s'\n";
static  char    *nou    =   "<nothing to undo>\n";
static  char    *noug   =   "<no undo with global>\n";
/**/
static  jmp_buf edjump;
/**/
static	char	*iam = 	"edcd";
static	char	*iwas = NULL;
/**/
ceterror()	/* dummy to give proper signal to eterror */
{
	eterror(SIGINT);
}
eterror(ty)
int		ty;
{
/**/
	signal(SIGINT,SIG_IGN);
	fuset((FUNCP) ignore);
/**/
	if(_undo == NO)  {
		errmsg("<FUBAR>");
		terror(FUBAR);
		}
/**/
	printff("\007<use Q to return to ked>\n");
/**/
	longjmp(edjump,0);
}
eubuf(ty)           /* set up undo buffer */
NOSIGN	ty;
{
	efseek(bfp,ub.ebufl[ub.elatch],0);
	if(ty == BWRT)  {
		wrcd(bfp,'w',0);
		fputc('\n',bfp);
		fflush(bfp);
		}
	else
	if(ty == BRDD)  {
		clcd();
		rdcd(bfp,'o');
		}
	return(ub.elatch = flop(ub.elatch));
}
eundo(nc)        /* do undo */
NOSIGN	nc;
{
	if(_undo == NO)     errmsg(noug);
	else
	if(cdx.del == NO)   errmsg(nou);
	else
	if(nc == 0)			eubuf(BRDD);
	else    {
		getcd(nc,CARD_IO);
		clact();
		eubuf(BWRT);
		eubuf(BWRT);
		cdx.del = 0;
	}
	epcmd3("Z");
	return(cdx.del);
}
/**/
edcard(os,cn)
NOSIGN    cn;	/* card number */
char    *os;	/* command string */
{
/**/
	auto	int	ret = ZERO;
	enom = cdx.del = NO;
	cdx.con = YES;
/**/
	if(cn >= 1 && cn <= cdx.lst)    {
		if(getcd(cn,CARD_IO))		return('E');
	}
/*
**	do commands in call string
*/
	_undo = NO;
/**/
	if(isnull(os))	strcpy(os,"Z");
/**/
	if((int)(ret = epcmd1(os)))  {
		return(ret);
		}
	if(kenv.prompt == NO)   {
		terror(FUBAR);
		}
/**/
	_undo = YES;
	eubuf(BSET);
	eubuf(BWRT);
	eubuf(BWRT);
/**/
	iwas = kenv.pname;
	disnme(kenv.pname = iam);
/**/
	sigint = signal(SIGINT,(FUNCS) eterror);
	sigfub = fuset( (FUNCP) ceterror);
/**/
	setjmp(edjump);
/**/
	signal(SIGINT,(FUNCS) eterror);
	fuset( (FUNCP) ceterror);
/**/
	enom = YES;
	return(erdcmp());
}
/**/
erdcmp()	/* prompt, read command */
{
	auto	char	ws[FNMSIZ];
	static	char	lc[FNMSIZ];
	auto	int	ret = ZERO;
	while(1)	{
/**/
	rdcmp(ws,ws+FNMSIZ-1,stdin,1,"edcd");
/**/
	if(ws[0] == '.' && ws[1] == ws[0])	strcpy(ws,lc);
	else					elc = strcpy(lc,ws);
/**/
	cdx.con = YES;
/**/
	if(cansyn)				get_syn(ws);
/**/
	if(isnull(ws))				strcpy(ws,"Z");
/**/
	if((int)(ret = epcmd1(ws)))      {
/**/
		disnme(kenv.pname = iwas);
/**/
		signal(SIGINT,(FUNCS) sigint);
		fuset((FUNCP) sigfub);
/**/
		return(ret);
/**/
		}
/**/
	}
}
epcmd1(is)  /* read through cmd|cmd|cmd sequences */
char    *is;
{
	auto	char	ws[FNMSIZ];
	auto	int		ret = ZERO;
	auto	char	*isx = is;
	while(!ret && cdx.con && (isx = xgnc(ws,ws+FNMSIZ-1,isx,'|')))	{
		if(isnull(ws))	strcpy(ws,"Z");
		ret = epcmd2(ws);
		}
	return(ret);
}
epcmd2(is)  /* execute no address commands */
char    *is;
{
	auto	NOSIGN	ret = 0;
	if(strchr(is,'/'))	epcmd3(is);
	else
	switch(*is)
	{
	case    '?':    khint("edcd",is+1);
	when	'F':	tellfile(VERBOSE);
	when    'f':    tellfile(TERSE);
	when	'k': 	keyslist();
	when    'M':    keysmem(stdout);
	when    'T':    edotime(is);
	when    'B':    edorandom(is);
	when	'I':	edofile(is);
	when    'N':    edonum(is);
	when    'Q':    ret = 'Q';
	when    'x':    ret = 'x';
	when    ZERO:
	case	'.':
	case    'q':    ret = 'q';
	when    'C':    cdx.del += 1;
					ret = 'C';
	when    'X':    cdx.del = NO;
					ret = 'X';
	when    'D':    cdx.del += 1;
					ret = 'D';
	when    'u':    eundo(0);
	when    'U':
	case    'R':    eundo(cdx.cur);
					break;
	case	'o':
	case	'O':	overx(fileno(stdin));
					break;
	default:        epcmd3(is);
					break;
	}   /* switch */
	return(ret);
}
char	*
endex(is,cx)		/* find first unescaped cx */
char	*is;
NOSIGN	cx;
{
	REG		char	*isx = is;
	REG		NOSIGN	cxx = cx;
	while(*isx != ZERO)
	if(*isx == ESC)			{
		isx += 1;
		if(*isx != ZERO)	isx += 1;
		}
	else
	if(*isx == cxx)			return(isx);
	else					isx += 1;
	return(NULL);
}
epcmd3(is)          /* execute commands with addresses */
char    *is;
{
	auto	char    *isx = is;
	auto	FUNCP	func = (FUNCP) NULL;
	prtype = prnumb = ZERO;
	if(*is == ZERO)     strcpy(is,"Z");
	if(isupper(*is) && !isalnum(is[1]))	{
		clact();
		mkact(NULL);
		*is = tolower(*is);
		isx = is;
		}
	else    {
		isx = endex(is,'/');
		if(isx) {
			*isx++ = ZERO;
			if(mkact(is) <= 0)  return(cdx.con = BAD);
			}
		else    {
			mkact(NULL);
			isx = is;
			}
		}
	switch(*isx)
	{
	case    'd':        func = (FUNCP) edodele;
	when    ZERO:
	case	'z':
	case    '#':
	case    'l':
	case    'h':
	case    'p':        func = (FUNCP) clist;
	when    'j':        func = (FUNCP) edojoin;
	when    'c':        if(isx[1] == 'o')   func = (FUNCP) edocopy;
						else                func = (FUNCP) edoch;
	when    'x':        func = (FUNCP) edoxch;
	when    'm':        func = (FUNCP) edomove;
	when    's':        func = (FUNCP) edosub;
	when	't':		func = (FUNCP) edotrans;
	when	'!':		func = (FUNCP) edoshell;
						break;
	default:            errmsg(bcd,isx);
						return(cdx.con = BAD);
	}
	if(func != (FUNCP) NULL)	(*func)(isx);
	return(cdx.con = YES);
}
clact()
{
	return(act[0] = 0);
}
ncset(is)
char	*is;
{
	while(*is != ZERO)
	if(isdigit(*is))	break;
	else				is += 1;
	return(atoi(is));
}
prset(is)		/* extract print specifications */
char	*is;
{
	REG		char	*isx;
	prnumb = prtype = 0;
	for(isx = is; *isx != ZERO; isx++)
	switch(*isx)	{
	default:		break;
	case	'#':	prnumb = *isx;
					prtype = prtype ? prtype : 'z';
					break;
	case	'H':
	case	'h':
	case	'p':
	case	'l':
	case	'z':
	case	'P':
	case	'L':
	case	'Z':	if(isupper(*isx)) 	prtype = tolower(*isx);
					else				prtype = *isx;
					break;
	}
	return(prtype);
}
clist(is)       /* print items in list */
char *is;
{
	auto    NOSIGN  i;
	auto	NOSIGN	cnt = 0;
	auto	NOSIGN	cl = kenv.leisur & DA;
	if(is)	{
		if(!prtype)	prset(is);
		}
	if(!prtype)		return(0);
	for(i = 1; i <= act[0]; i++)
	if(!isnull(kd[act[i]].data)) {
		if(cl)	{
			scr_cl(stdout);
			cl = 0;
			}
		if(prnumb)	{
			printf("(%d)\n",cdx.cur);
			prnumb = 0;
			cnt += 1;
			}
		cdprp(act[i],stdout,prtype,kenv.folder);
		cnt += 1;
	}
	if(cnt)             fputc('\n',stdout);
	fflush(stdout);
	return(i);
}
edosub(is)      /* do substitution */
char    *is;
{
	auto	NOSIGN 	i = 0;
	auto	NOSIGN	gl = 0;
	auto	NOSIGN	bl = 0;
	auto	NOSIGN	ns = 0;
	if(act[0] < 0) {
		errmsg(nad,lx);
		eterror(FUBAR);
	}
/**/
	del = NO;
/**/
	subparse(is,(FUNCP) eterror,xp,4,&gl,&bl);
/**/
	prtype = prset(xp[2]);
/**/
	for(i = 1; i <= act[0]; i++) {
		kdo = &kd[act[i]].data;
		if(isnull(*kdo)) continue;
		ns = dsub(kb.base,kb.bmax,*kdo,xp[1],gl,bl);
		if(ns >= 1)
			{
			del += 1;
			*kdo = free_if(*kdo);
			if(!isnull(kb.base))    *kdo = strsave(kb.base);
			}
		}
/**/
	if(!del)	{
		if(cdx.glb == NO && enom == 1)	{
			errmsg("<no match> '%s'\n",xp[0]);
			}
	}
	return(cdx.del = prundo(del,cdx.del));
}
prundo(del,led)		/* print and save for undo */
NOSIGN	del;
NOSIGN	led;
{
	if(del) {
		if(_undo)    eubuf(BWRT);
		if(prtype)	 printit(prtype);
		return(del);
	}
	else	return(led);
}
mkact(is)   	/* make act - command list */
char *is;
{
	return(act[0] = keylist(act+1,NACTS-1,is));
}
edotrans(is)    /* transformation (rotation) */
char *is;
{
	REG		NOSIGN	i;
	auto	NOSIGN	nc = 1;
	auto	char	*ps = "::";
	auto	char	*psx;
	del = NO;
/*  k1,k2,kn/t[p][1-9]/[pat]    */
	is = strtoc(psx = is,'/');
	prtype = prset(psx);
	nc = ncset(psx);
	if(!isnull(is))	ps = is;
/**/
	for(i = 1; i <= act[0]; i++)    {
		kdo = &kd[act[i]].data;
		if(isnull(*kdo))     continue;
		transpose(*kdo,ps,nc);
		del += 1;
	}
/**/
	return(cdx.del = prundo(del,cdx.del));
}
edoch(is)   /* perform change */
char *is;
{
	REG		NOSIGN		i;
	auto	char		*psx;
/**/
	del = NO;
/**/
	is = strtoc(psx = is,'/');
/**/
	prtype = prset(psx);
/**/
	splitc(xp,4,is,'/');
/**/
	for(i = 1; i <= act[0]; i++) {
		kdo = &kd[act[i]].data;
		*kdo = free_if(*kdo);
		if(isnull(xp[0]))       continue;
		else                    *kdo = strsave(xp[0]);
		del += 1;
		}
/**/
	return(cdx.del = prundo(del,cdx.del));
}
edoxch(is)  /* exchange */
char *is;
{
	auto	char	*bx;
	auto	char	*psx;
	if(act[0] > 1)  {
		errmsg(tma,elc);
		eterror(FUBAR);
	}
/**/
	del = NO;
/**/
	is = strtoc(psx = is,'/');
/**/
	prtype = prset(psx);
/**/
	act[2] = iskey(is);
	if(act[2] < 0 || act[2] == act[1]) {
		errmsg(nad,lx);
		eterror(FUBAR);
	}
/**/
	kdo = &kd[act[1]].data;
	kdt = &kd[act[2]].data;
/**/
	bx = *kdt;
	*kdt = *kdo;
	*kdo = bx;
/**/
	act[2] = act[2];
	act[0] = 2;
	return(cdx.del = prundo(1,cdx.del));
}
edomove(is)     /* move */
char *is;
{
	auto		char	*psx;
	if(act[0] > 1)  {
		errmsg(tma,elc);
		eterror(FUBAR);
	}
/**/
	is = strtoc(psx = is,'/');
	prtype = prset(psx);
/**/
	act[2] = iskey(is);
	if(act[1] < 0 || act[1] == act[2])  {
		errmsg(nad,lx);
		eterror(FUBAR);
		}
/**/
	del = NO;
	kdo = &kd[act[1]].data;
	kdt = &kd[act[2]].data;
/**/
	if(isnull(*kdo))	nullso("move");
	else	{
		*kdt = *kdo;
		*kdo = NULL;
		act[1] = act[2];
		act[0] = 1;
		++del;
	}
	return(cdx.del = prundo(del,cdx.del));
}
nullso(is)
char	*is;
{
	errmsg("%s <source field is empty>\n",is);
	return(0);
}
edocopy(is)     /* copy */
char *is;
{
	auto	char	*psx;
	del = NO;
	if(act[0] > 1)  {
		errmsg(tma,elc);
		eterror(FUBAR);
	}
/**/
	is = strtoc(psx = is,'/');
	prtype = prset(psx);
/**/
	act[2] = iskey(is);
	if(act[2] < 0 || act[2] == act[1])  {
		errmsg(nad,lx);
		eterror(FUBAR);
	}
	kdo = &kd[act[1]].data;
	kdt = &kd[act[2]].data;
	if(isnull(*kdo))	nullso("copy");
	else					{
		*kdt = stringer(*kdo,*kdt);
		act[1] = act[2];
		act[0] = 1;
		++del;
	}
	return(cdx.del = prundo(del,cdx.del));
}
edoshell(is)	/* do a shell using data from key */
char	*is;
{
	auto	int		i;
	auto	char	ws[FNMSIZ];
	auto	char	*wsx;
	auto	char	*wsu;
	for(i = 1; i <= act[0]; i++)	{
		if(kd[act[i]].data == NULL)	continue;
		wsx = ws;
		wsu = wsx + FNMSIZ - 1;
		wsx = strkat(wsx,wsu,is);
		wsx = strkat(wsx,wsu," ");
		wsx = strkat(wsx,wsu,kd[act[i]].data);
		dosh(ws);
		}
	return(ZERO);
}
edodele(is)     /* delete */
char *is;
{
	auto	NOSIGN	i;
	del = NO;
	prtype = prset(is);
	for(i = 1; i <= act[0]; i++)    {
		kdo = &kd[act[i]].data;
		if(*kdo)	{
			++del;
			*kdo = free_if(*kdo);
			}
	}
	return(cdx.del = prundo(del,cdx.del));
}
edojoin(is)
char    *is;
{
	auto	NOSIGN	i;
	auto	char	*psx;
	auto	int	nt;
	del = NO;
/*  k1,k2,kn/j[p][/kt] */
	is = strtoc(psx = is,'/');
	prtype = prset(psx);
/**/
	if(!isnull(is))	nt = iskey(is);
	else            nt = act[1];
/**/
	if(nt < 0)  {
		errmsg(nad,lx);
		eterror(FUBAR);
	}
/**/
	kdt = &kd[nt].data;
/**/
	if(isnull(*kdt))	{
		kb.used = kb.base;
		}
	else					{
		kb.used = strkat(kb.base,kb.bmax,*kdt);
		free_if(*kdt);
		}
/**/
	for(i = 1; i <= act[0]; i++)	{
		++del;
		if(kb.used > kb.base)	{
			kb.used = strkat(kb.used,kb.bmax,"::");
			}
		kdo = &kd[act[i]].data;
		if(*kdo)			{
			kb.used = strkat(kb.used,kb.bmax,*kdo);
			}
		}
	if(kb.used >= kb.bmax)  {
		errmsg(nco,lx);
		eterror(FUBAR);
	}
	if(kb.used > kb.base)	kd[nt].data = strsave(kb.base);
	act[0] = 1;
	act[1] = nt;
	return(cdx.del = prundo(del,cdx.del));
}
#ifdef	__MEDIUM__
edofile(is)      /* file name */
char    *is;
{
	if((act[1] = iskey("file")) < 0)   {
		errmsg("<no 'file' key in your '.keys'>\n");
		terror(FUBAR);
	}
	prtype = prset(is);
	act[0] = 1;
	kdo = &kd[act[1]].data;
	*kdo = free_if(*kdo);
	*kdo = strsave(efnget());
	return(cdx.del = prundo(1,cdx.del));
}
#else
edofile(is)
char	*is;
{
	errmsg("edofile <not implemented>\n");
	eterror(FUBAR);
	return(0);
}
#endif
#ifdef	__MEDIUM__
edonum(is)      /* number record */
char    *is;
{
	auto	char    ws[16];
	if((act[1] =iskey("num")) < 0)   {
		errmsg("<no 'num' key in your '.keys'>\n");
		terror(FUBAR);
	}
	prtype = prset(is);
	act[0] = 1;
	*kdo = kd[act[1]].data;
	itos(ws,cdx.cur);
	*kdo = free_if(*kdo);
	if(!isnull(ws)) *kdo = strsave(ws);
	return(cdx.del = prundo(1,cdx.del));
}
#else
edonum(is)
char	*is;
{
	errmsg("edonum <not implemented>\n");
	eterror(FUBAR);
	return(0);
}
#endif
#ifdef	__MEDIUM__
edotime(is)      /* time stamp */
char    *is;
{
/*
	T	time stamp
	n	numeric (DA)
	s	string (DB)
	p	print (DC)
	o	write over previous time stamp (DD)
*/
	auto	NOSIGN 	style = 0;
	auto	char    ws[64];
	auto	long	now;
	if((act[1] =iskey("time")) < 0)   {
		errmsg("<no 'time' key in your '.keys'>\n");
		terror(FUBAR);
	}
	act[0] = 1;
	kdo = &kd[act[1]].data;
	ws[0] = ZERO;
/**/
	prtype = prset(is);
/**/
	while(*is != ZERO)
	switch(*is++)	{
	case	'n':	style |= DA;
	when	's':	style |= DB;
	when	'o':	style |= DD;
	when	'T':	break;
	default:		break;
	}
	if(style & DA)	;
	else
	if(style & DB)	;
	else			style |= (DA | DB);
	if(style & DD)	{
		*kdo = free_if(*kdo);
		}
	if(isnull(*kdo))	{
		time(&now);
		if(style & DA)	sprintf(ws,"%ld ",now);
		if(style & DB)  sprintf(ws+strlen(ws),"%s",ctime(&now));
		*kdo = strsave(strcnd(ws));
		cdx.del = prundo(1,cdx.del);
	}
	return(cdx.del);
}
#else
edotime(is)
char	*is;
{
	errmsg("edotime <not implemented>\n");
	eterror(FUBAR);
	return(0);
}
#endif
edorandom(is)      /* time stamp */
char    *is;
{
/*
	R	random number
	p	print (DC)
	o	write over previous time stamp (DD)
*/
	auto	NOSIGN 	style = 0;
	auto	char    ws[16];
	if((act[1] =iskey("rand")) < 0)   {
		errmsg("<no 'rand' key in your '.keys'>\n");
		terror(FUBAR);
	}
	act[0] = 1;
	kdo = &kd[act[1]].data;
	ws[0] = ZERO;
/**/
	prtype = prset(is);
/**/
	while(*is != ZERO)
	switch(*is++)	{
	when	'o':	style |= DD;
	when	'T':	break;
	default:		break;
	}
	if(style & DA)	;
	else
	if(style & DB)	;
	else			style |= (DA | DB);
	if(style & DD)	{
		*kdo = free_if(*kdo);
		}
	if(isnull(*kdo))	{
		itos(ws,rand());
		*kdo = strsave(strcnd(ws));
		cdx.del = prundo(1,cdx.del);
	}
	return(cdx.del);
}
char	*
transpose(is,ps,nc)	/* transpose nc-th occurence of ps marked is */
char	*is;
char	*ps;
{
	REG		char	*isx = is;
	auto	int		lp = strlen(ps);
	if(isnull(is))		return(is);
	nc = nc >= 1 ? nc : 1;
	while(nc >= 1 && *isx != ZERO)
	if(*isx == ps[0] && strncmp(isx,ps,lp) == 0)	{
			nc -= 1;
			if(nc == 0)	{
				strnrev(isx,lp);
				strnrev(is,isx-is);
				strnrev(is,(isx+lp)-is);
				strrev(isx+lp);
				strnrev(is,(isx+lp)-is);
				strrev(is);
				return(is);
				}
			else	isx += lp;
			}
	else	isx += 1;
	return(is);
}
