/*
	12:28:88	quick patch to ksl for MSDOS tfp = stderr
*/
#define		DEBUG
#undef		DEBUG
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
/**/
#ifdef		MSDOS
#include	"ksysgtty.h"
#else
#include    <sgtty.h>
#endif
/**/
#include    <signal.h>
/**/
#define     DEVNULL     "/dev/null"
#define     DEVTERM     "/dev/tty"
#define     TRMWAIT     120         /* wait on terminal reads */
/*EXTERNAL*/
/**/
xsl(nv,is)          /* slow the output */
char    *is;
{
/*
**  sl == 0 -> off
*/
	return(sl = setvar(nv,is,ABSO,0,0));
}
zsl(nv,lo)          /* slow the output */
{
	static      int     fd;
	static      int     cx;
	auto        int     loop = 1;
	auto        int     to;
	if(nv >= 1)         			dump("zsl:nv");
	if(nx >= 1 && x[nv].lo < nx)	return(sl);
	if(nx >= 1 && x[nv].lo >= nx)	si = zsi(nv,0);
	if(si >= 1)						return(sl);
	nx = 0;
#ifdef	NOTTY
	if(!isatty(fileno(x[nv].ofp)))	{
		errmsg("zsl <not a tty>\n");
		terror(FUBAR);
		}
#else	NOTTY
	if(!isatty(fileno(x[nv].ofp)))	{
		return(sl = ZERO);
		}
#endif	NOTTY
	if(kenv.dosdos)	tfp = stderr;
	else	{
		if(tfp == (FILE * ) NULL) {
#ifdef	SUN
			tfp =fdopen(dup(2),"w+");
#else
			tfp = tefopen(DEVTERM,"w+");
#endif
			setbuf(tfp,NULL);
			fd = fileno(tfp);
			}
		}
/**/
	cbc_on(fd);
/**/
	to = alarm(TRMWAIT);
/**/
	signal(SIGINT,SIG_IGN);
#ifdef	MSDOS
#endif
/**/
	fflush(x[nv].ofp);
	while(loop >= 1)	{
	ttce(x[nv].ofp);
	fprintf(x[nv].ofp,"(%d:%d)?",x[nv].cp,x[nv].vp);
	fflush(x[nv].ofp);
	if(kenv.dosdos)	cx = keyget(ZERO);
	else			cx = getc(tfp);
	switch(cx)  	{
	case	'r':	rewind(x[nv].ifp);
					loop = 0;
					break;
	case    'q':    cleanup(0);
					cbc_off(fd);
					exit(0);
	case    'x':
	case    'v':
	case    '.':
	case    '!':    
					alarm(to);
					zsl1(nv,tfp,cx);
					break;
	case    '0':
	case    '1':
	case    '2':
	case    '3':
	case    '4':
	case    '5':
	case    '6':
	case    '7':
	case    '8':
	case    '9':    
					alarm(to);
					nx = zsl2(nv,tfp,cx);
					si = zsi(nv,1);
					loop = 0;
					break;
	default:        loop = 0;
					break;
	}
	}
/**/
	if(tfp == NULL)	dump("tfp is null");
	erase("                ",tfp);
/**/
	cbc_off(fd);
/**/
	signal(SIGINT,terror);
#ifdef	MSDOS
#endif
/**/
	if(x[nv].ofp == NULL)	dump("x[nv].ofp is null");
	if(kenv.dosdos)	scr_cl(x[nv].ofp);
	else		ttclr(x[nv].ofp);
/**/
	fflush(x[nv].ofp);
/**/
	alarm(to);
	return(sl);
}
zsl1(nv,tfp,cx)     /* shell escapes for slow */
FILE    *tfp;
{
	auto    char    ws[BLKSIZ];
	auto    int     nr;
	cbc_off(fileno(tfp));
	putc(cx,tfp);
	if(cx == 'x')   nr = doshell(strcpy(ws,"ex +1 %"),
						filepush(filepop()),NULL);
	else
	if(cx == 'v')   nr = doshell(strcpy(ws,"vi +1 %"),
						filepush(filepop()),NULL);
	else
	if(cx == 's')   nr = doshell(strcpy(ws,"sh -i"),NULL,NULL);
	else
	if(cx == '!')   nr = doshell(fgets(ws,BLKSIZ-1,tfp),
					filepush(filepop()),NULL);
	else
	if(cx == '.')   {
					ws[0] = cx;
					fgets(ws+1,BLKSIZ-1,tfp);
#ifdef	DEBUG
	fprintf(stderr,"zsl1: ");
	funxesc(ws,stderr);
#endif
					xcmd(nv,ws);
					}
	cbc_on(fileno(tfp));
	return(nr);
}
zsl2(nv,fp,cx)          /* get number for slow */
FILE    *fp;
{
	auto    char    ws[16];
	auto    char    *wsx = ws;
	*wsx++ = cx;
	while((cx = getc(fp)) != EOF && isdigit(cx))    *wsx++ = cx;
	*wsx = ZERO;
	if(cx == 'p')   {
		auto	int		lo;
		lo = x[nv].lo;
		lo = ((lo + x[nv].pl)/x[nv].pl) * x[nv].pl;
		lo += (atoi(ws) * x[nv].pl);
		return(lo);
		}
	else
	if(cx == 'l')   return(atoi(ws)+x[nv].lo);
	else
	if(cx == 's')   return(atoi(ws)*sl+x[nv].lo);
	else            return(0);
}
zsi(nv,ty)      /* silence output */
{
	static  FILE    *nfp = (FILE *) NULL;        /* bin bucket */
	static  FILE    *sfp = (FILE *) NULL;        /* saved FILE */
	if(nv > 0)      { badenv(nv,"xsi",FUBAR); }
/**/
	if(nfp == NULL) {
		nfp = tefopen(kenv.dosdos ? "NUL" : DEVNULL,"w");
		}
/**/
/*  silence */
	if(ty == 1) {
		if(x[nv].ofp == nfp)    return(si);
		else    {
			fflush(x[nv].ofp);
			sfp = x[nv].ofp;
			x[nv].ofp = nfp;
			return(si = 1);
		}
	}
/*  restore output */
	else
	if(ty == 0) {
		if(sfp == nfp)  return(si);
		else    {
			fflush(nfp);
			x[nv].ofp = sfp;
			sfp = nfp;
			return(si = 0);
		}
	}
	return(0);
}
