#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "ksysprot.h"
#include    "ksyskwik.h"
#ifdef      TEST
KENV        kenv;
void
terror(ty)
int     ty;
{
    exit(ty);
}
main()
{
    disnme(kenv.pname = "test");
    exit(hint(0));
}
#endif      TEST
hint(ty)
int     ty;
{
static  char    *hx[] = {
"=",
"kwik [-options] [-e expr] [file(s)]",
"=COMMAND LINE",
"-Bnnnn    set io buffers to BUFSIZ * nnnn [16]",
"-bnnnn    set card or paragraph buffer to nnnn [4096]",
"-C        clear between record displays",
"-Dnn      diagnostic level",
"-E        echo records written to a named file",
"-e expr   find the expression in the named file(s)",
"          'expr1 expr2' -> expr1 AND expr2",
"          expr1+expr2 -> expr1 AND expr2",
"-Fnn      fold terminal output at NN characters [64]",
"-Gnn      set granularity for hashed index [GRANULE]",
"-Hnn      set modulo factor for hashed searches [MODFAC]",
"-h        command summary",
"-l        read input line by line",
"-M        do not look for an initial commands/macro file",
"-Q        query after each display",
"-Rnn      report level [0]",
"-Sn       format for output (see FORMAT below)",
"-T        timing information (toggle) [off]",
"-t        read as [knt]roff text",
"-u file   use the named hash file for searching (-e)",
"-V        verify writes to a named output file",
"-W        tell the program name and creation date",
"-x file   make the named hash file for searching (-e)",
"=",
"~",
"=GENERAL INTERACTIVE COMMANDS",
"*",
"@         separates a sequence of commands given as one line",
"X nn      any command line option of the form -Xnn",
"X string  any command line option of the form -X string",
"*",
"/string   set the next search pattern to string",
":         comment (ignored; tabs not allowed)",
"!cmd      shell command",
"cd [dir]  change to directory",
"so file   use commands from file",
"f         show file characteristics",
"=",
"~",
"=SYNONYMS, MACROS",
"syn               show macros",
"syn save file     save current macros in file",
"                  (use 'so file' to read in macros)",
"syn def nm tx     define name to be text",
"syn def nm        remove name",
"syn echo          echo commands after expansion",
"syn noecho        turn off echoing",
"syn undef nm      remove (undefine) the named macro",
"syn zap           undefine all macros",
"                  (also removes saved data for & operator in",
"                  a, i, and o functions)",
"=",
"*     on starup macros and other commands are read from the",
"*     first existing file in the series",
"*     ./kwik.mac $HOME/kwik.mac $PUBKIN/kwik.mac",
"*     the search for the initial macro file may be suppresed",
"*     by -M on the command line",
"=",
"~",
"=SELECTION COMMANDS",
"gc        make a compressed search",
"gh        make a hash search",
"gk        make a krep style search",
"p         print the last pattern",
"q         quit",
"=INPUT FILE COMMANDS",
"r file(s) set read file list",
"r         read last output file",
"*",
"*         wild cards and shell variables are expanded",
"*",
"=",
"~",
"=INDEX (HASHED)",
"Gnn       set the granularity for hashed index [64]",
"Hnn       set the hash modulo factor [4091]",
"s [file]  save index as file [kwikfind.ref]",
"u [file]  use a previous index file [kwikfind.ref]",
"          (ignores any input file list)",
"x [file]  index the current input file list [kwikfind.ref]",
"z         view the zap (exclusion) list",
"Z [file]  remove named file [kwikfind.ind]",
"=",
"~",
"=FORMAT AND DISPLAY",
"C         clear screen between displays",
"E         echo when writing to a named file",
"N string  specify a note string",
"Q         query after write",
"S1        card",
"S2        number",
"S3        file name",
"S4        note (see N)",
"V         verification (toggle)",
"=",
"~",
"=OUTPUT FILES",
"w         write to stdout",
"w file    write to file",
"w !cmd    write to command",
"w! file   overwrite file",
"w>>file   append to file",
"=VIEWING FILES",
"m         view the current output file",
"m file    view the named file",
"m         view the input file(s)",
"M file(s) view the named file(s)",
"=",
"~",
"=PATTERN MATCHING (KREP STYLE)",
"abc          pattern match of abc",
"\\<abc\\>      word match of abc",
".            any one character",
"^            beginning of line",
"$            end of line",
"!pattern     negation",
"[abc]        set or range [a-z]",
"[^abc]       not in set or range [a-z]",
"*            0 or more cases of previous pattern",
"=EXTENDED PATTERN MATCHING (KREP STYLE)",
"(#abc&&xyz)  pattern xyz in field abc",
"abc|xyz      or",
"abc&xyz      and",
"(abc&xyz)    grouping",
"\\w           all patterns as words",
"\\i           ignore case",
"\\m           literal metacharater (^, $, . , !)",
"=",
"~",
"=PATTERN ABBREVIATIONS (KREP STYLE)",
"|list     generate pattern (word|word|word)",
"&list     generate pattern (word&word&word)",
"/pattern  set pattern for next search",
"*",
"*         depending on composition, the same pattern may be used",
"*         in all types of searches.",
"*",
"=",
"~",
"=COMPRESSED/HASHED PATTERN MATCHING",
"*",
"*            blank separated lists of words.",
"*            case and punctuation are IGNORED.",
"*            all words must be present for a match.",
"*",
"=",
"~",
"=EXAMPLES",
"*",
"*          kref",
"*",
"*              starts in interactive mode",
"*",
"*          kref -u joincard.ind -e 'kinmonth self-made man'",
"*",
"*              uses a previously created hash index to find the",
"*               expression 'kinmonth(and)self-made(and)man'",
"*",
"*          kref -e '&Kinmonth Self-Made' file.1 file.2",
"*",
"*              uses extended grep-style matching to find",
"*              Kinmonth(and)Self-Made in file.1 and file.2",
"*",
"=",
"~",
"=QUOTATION",
"*",
"*      depending on the shell and its operating mode, patterns",
"*      containing blanks may require single quoting, double quoting,",
"*      or escaped quoting!",
"=",
"~",
"=SHELL VARIABLES",
"*",
"KWIKEXPR   used in lieu of -e",
"KWIKINDEX  used in lieu of -u, -x",
"KWIKFILES  used in lieu of command line file list",
"*",
"=",
"~",
}   ;
    prhint(hx,sizeof(hx)/sizeof(char**),NULL,ZERO);
    return(ty);
}
