/*DOSLIB*/
#ifdef	__TURBOC__
#include	<stdio.h>
#include	<fcntl.h>
#include	<time.h>
#include	<dos.h>
#include	<io.h>
#include	<sys/stat.h>
#define		U2D		0
#define		D2U		1
/**/
static	long	ktimestd(long,int);
static	long	utimestd(void);
static	long	dtimestd(void);
long
dtimestd()
{
	auto	struct	date	dos_date;
	auto	struct	time	dos_time;
/*
|	establish the long integer value corresponding to 1989:01:01:00:00
|	under the host version of MSDOS
*/
	dos_date.da_year = 1989;
	dos_date.da_day = 1;
	dos_date.da_mon = 1;
	dos_time.ti_min = 0;
	dos_time.ti_hour = 0;
	dos_time.ti_hund = 0;
	dos_time.ti_sec = 0;
	return(dostounix(&dos_date,&dos_time));
}
long
utimestd()
{
#define	UTIMESTD	599644800L	/* 1989:01:01:00:00 */
	return(UTIMESTD);
}
long
ktimeutd(ct)	/* unix to dos */
long	ct;
{
	return(ktimestd(ct,U2D));
}
long
ktimedtu(ct)	/* dos to unix */
long	ct;
{
	return(ktimestd(ct,D2U));
}
long
ktimestd(ct,ty)	/* convert time standard */
long	ct;		/* time to be converted */
int		ty;		/* type of conversion */
{
	static	long	dt = 0L;
	if(dt == 0L)	{
		dt = utimestd() - dtimestd();
		}
/**/
	if(ty == D2U)	{	/* dos to unix */
		if(dt > 0L)	ct += dt;
		else
		if(dt < 0L)	ct -= dt;
		}
	else
	if(ty == U2D)	{	/* unix to dos */
		if(dt > 0L)	ct -= dt;
		else
		if(dt < 0L)	ct += dt;
		}
	else	dump("ktimestd: ty bad");
/**/
	return(ct);
/**/
}
#endif	/*__TURBOC__*/
