/*DOSLIB*/
/*UNXLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	<sys/types.h>
#include	<sys/stat.h>
/*EXTERN*/
#ifndef	_Cdecl
#define	_Cdecl	/**/
#define	const	/**/
#endif
/**/
#ifdef	CAN_PROTO
extern int shark(int, char **);
extern char *ctime(long *);
extern void header(char *);
extern int _Cdecl system(const char *);
extern int fprintf();
extern int sprintf();
extern int printf();
extern char *getcfn(void);
extern void hint(FILE *);
extern void errmsg();
extern void doshar(FILE *);
extern int isbinary(FILE *);
#else
extern int shark();
extern char *ctime();
extern void header();
extern int system();
extern int fprintf();
extern int printf();
extern char *getcfn();
extern void hint();
extern void errmsg();
extern void doshar();
extern int isbinary();
#endif
/*GLOBAL*/
long	now;
KENV	kenv;
#ifdef	MSDOS
static	char	*rmode = "rb";
#else
static	char	*rmode = "r";
#endif
static	char	ls[BUFSIZ];
static	char	fn[BUFSIZ];
static	long	fs;
void
terror(ty)
int	ty;
{
/* ### Warning shark.c 55: Call to function 'errmsg' with no prototype in function terror === */
	errmsg("<terror> %d\n",ty);
	exit(ty);
	return;
}
static	char	*hx[] = {
	"=",
	"shark [file(s)]",
	"=",
	"*",
	"*     make a shell archive from the named files.",
	"*",
	"*     binary files are passed through uuencode.",
	"*",
	"=",
	NULL,
	NULL,
}	;
void
hint(fp)
FILE	*fp;
{
/**/
	prhint(hx,sizeof(hx)/sizeof(char *),ZERO,ZERO);
/**/
	if(fp == stdout)	exit(0);
	else
	if(fp == stderr)	exit(69);
	return;
}
main(argc,argv)
int		argc;
char	*argv[];
{
/**/
	kenv.dosdos = isdos();
	disnme(kenv.pname = "shark");
/**/
	if(cmdnum(argc,argv,'h',0,DA))	hint(stdout);
/**/
	kenv.blockd = cmdnum(argc,argv,'B',16,16) * bufsiz();
/**/
	exit(cmdxrc(argc,argv,shark,"shark.xrc"));
	return(0);	/* LINT */
}
shark(argc,argv)
int		argc;
char	*argv[];
{
/**/
	if(kenv.dosdos)	cmdxpd(argc,argv);
	else			telluser(kenv.pname);
/**/
	time(&now);
/**/
	header(ctime(&now));
/**/
	dolist(argc,argv,(FUNCP) doshar);
	return(0);
}
void
header(is)
char	*is;
{
	printf("#!  /bin/sh\n");
	printf("#   this is a shark (kinmonth shar) archive\n");
	printf("#   extract with /bin/sh (not csh)\n");
	printf("#   binary files are encoded with uuencode\n");
	printf("#   blanks in the encoded file have been converted\n");
	printf("#   to 'z'\n");
	printf("#   be alert for damage due to mailers\n");
	printf("#   packed %s",is);
	printf("#\n");
	fflush(stdout);
	return;
}
void
doshar(fp)
FILE	*fp;
{
	auto	char	*cfn = getcfn();
	auto	int		binary = isbinary(fp);
	auto	char	*script = "/^begin/n\n/^end/n\ns/z/ /g\n";
	auto	char	*scrapt = "/^begin/n\n/^end/n\ns/ /z/g\n";
	rewind(fp);
	printf("if test -r %s\n",cfn);
	printf("then echo \"will not overwrite %s\"\n",cfn);
	printf("else\n");
	if(binary)	{
		auto	char	ws[FNMSIZ];
		printf("sed -e '%s' <<\\END_%s | uudecode\n",script,cfn);
		fflush(stdout);
/*	CTEXT:	seem to need a flush before system() */
		sprintf(ws,"uuencode %s < %s | sed -e '%s'",cfn,cfn,scrapt);
		system(ws);
		}
	else	{
		printf("sed -e 's/^X//' - <<\\END_%s > %s\n",cfn,cfn);
		while(fgetls(ls,ls+BUFSIZ-1,fp))	{
			printf("X%s\n",ls);
			}
		}
	printf("END_%s\n",cfn);
	printf("chmod +w %s\n",cfn);
	printf("chmod +x %s\n",cfn);
	printf("echo \"extracted %s\"\n",cfn);
	printf("fi\n");
	fflush(stdout);
	return;
}
isbinary(fp)		/* is this a binary file? */
FILE	*fp;
{
	REG		int		cx;
/**/
	while((cx = getc(fp)) != EOF && isascii(cx))	;
/**/
	if(cx != EOF)	return(1);
	else			return(0);
}
