#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"ksyskref.h"
/*EXTERN*/
/**/
dobibl(is,fa)		/* loop through bibl files */
char	*is;		/* list of bibliographies */
FUNCP	fa;
{
	auto	char	*fno;
	auto	char	*fnx;
	auto	char	*fzz;
	fzz = fno = fnx = strsave(is);
	while((int)(fnx = strtoc(fno = fnx,' ')))	{
		doabibl(fno,fa);
	}
	free_if(fzz);
/*	if comment mode, all done here */
	if(kenv.flags0 & DD)	return(ZERO);
/**/
	if(kenv.flags2 & DB)	ambiguity();
	if(kenv.flags3 & DB)	notfound();
/**/
	if(kenv.flags2 & DF)	{
		errmsg("<killed for AMBIGUITY: check -a option>\n");
		terror(FUBAR);
		}
	return(0);
}
doabibl(is,fa)		/* read one bibl, extract matched cards */
char	*is;		/* bibliography name */
FUNCP	fa;
{
	auto	FILE	*ifp = NULL;
	auto	char	*ifb = NULL;
	auto	char	*cfn = NULL;
	auto	int		cd = 0;
	auto	char	*cp = NULL;
	auto	long	size;
/**/
	if(kenv.report & DA)	{
		size = filesize( is );
		drawset(size,50,'=','B','>');
		}
/**/
	cfn = strsave(is);
/**/
	if(!(int) (ifp = efopen(is,kenv.dosdos ? "rb" : "r")))	terror(FUBAR);
#ifdef	SYSV
	ifb = ksetvbuf(ifp,ifb,_IOFBF,kenv.blockd);
#endif	/*SYSV*/
/**/
	while((int)(cp = xrdcd(bufo,bufu,ifp)))	{
/**/
		if(kenv.report & DA && cd % 100)	{
			size = ftell( ifp );
			drawline(size,stderr);
			}
/**/
		cd += 1;
		cp += 1;
		kpc(cp,bufu,bufo);
		(*fa)(bufo,cp,cd,cfn);
		/* addwork(bufo,cp,cd,cfn); */
	}
/**/
	if(kenv.report & DA)	drawclear(stderr);
/**/
	ifp = xfclose(ifp);
	ifb = free_if(ifb);
/**/
	return(cd);
}
ambiguity()
{
	auto	FILE	*err = stderr;
	auto	BS		*bsx = bso;
	auto	int		bad = 0;
	auto	FUNCP	func;
	if(kenv.flags2 & DE)	err = stdout;
	if(isatty(fileno(err)))	func = (FUNCP) xwrcdf;
	else					func = (FUNCP) xwrcd;
/**/
	while(bsx->bs)	{
		if(bsx->nd > 1)	{
			auto	int		ix;
			for(ix = 0; ix < bsx->nd; ix++)	{
				fseek(wfp,bsx->da[ix]-1L,0);
				fprintf(err,"ERR AMBIGUITY\n");
				fprintf(err,"KEYS ");
				prpat(bsx->bs,err);
				xrdcd(bufo,bufu,wfp);
				(*func)(bufo,err,kenv.folder,NULL);
				}
			bad += 1;
			}
		bsx += 1;
	}
	return(bad);
}
notfound()
{
	auto	FILE	*err = stderr;
	REG		BS		*bsx = bso;
	auto	int		nf = 0;
/**/
	if(kenv.flags2 & DE)	err = stdout;
/**/
	while(bsx->bs)	{
		if(bsx->nd == 0)	{
			fprintf(err,"NOT FOUND ");
			prpat(bsx->bs,err);
			nf += 1;
		}
		bsx += 1;
	}
/**/
	if(nf)	{
		errmsg("<killed for NOT FOUND: check -u option>\n");
		terror(FUBAR);
		}
/**/
	return(nf);
}
