/*COMLIB*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
/*EXTERN*/
extern	KENV	kenv;
/*GLOBAL*/
#ifdef	CAN_PROTO
static char *error(int);
#else	/*CAN_PROTO*/
static char *error();
#endif	/*CAN_PROTO*/
/*STATIC*/
static	char	*
error(ty)
int		ty;
{
#define	DOL	'$'
#define	X_CORE	0
#define	X_OVER	1
	static	char	*em[] = {
		"dosxenv <no core>",
		"dosxenv <overflow>",
	}	;
	errmsg(em[ty]);
	fubar(FUBAR);
	return(NULL);
}
char	*
dosxenv(is)			/* expand shell vars in _os */
char	*is;		/* input-output string */
{
#ifdef	TRACE
	auto	int		barf = fprintf(stderr,"dosxenv(%u,%u)\n",os,us);
#endif	TRACE
	auto	char	ws[FNMSIZ];
	auto	char	*isx = is;
	auto	char	*os = emalloc(BLKSIZ,"dosxenv");
	auto	char	*osx = os;
	auto	char	*osu = osx + BLKSIZ - 2;
/**/
	if(os == NULL)	return(error(X_CORE));
/**/
	while(osx < osu && *isx != ZERO)	{
	if(*isx == ESC && isx[1] == DOL)	{
		*osx++ = isx[1];
		isx += 2;
		}
	else
	if(*isx == DOL)	{
		auto	char	*shv;
		isx = stralnum(ws,ws+FNMSIZ-1,isx+1);
		shv = kgetenv(ws);
		if(shv != NULL)	osx = strkat(osx,osu,shv);
		}
	else	{
		*osx++ = *isx++;
		}
	}
	*osx++ = ZERO;
/**/
	if(osx >= osu)	return(error(X_OVER));
/**/
	is = strsave(os);
	if(is == NULL)	return(error(X_CORE));
	os = free_if(os);
/**/
	return(is);
}
