#include	"pdtar.h"
#include	"pdproto.h"
/**/
rdwrfile(f_name,begin,size)
char	*f_name;	/* file name */
long	begin;	/* starting point */
long	size;	/* number of characters to read */
{
	static	char	*here = "rdwrfile";
	static	int		mode = O_RDONLY | O_BINARY;
	auto	long	rsize;
	auto	int		read_ifd = 0;
	auto	int		nci = 0;
	auto	int		nco = 0;
	auto	int		blk = 0;
/*
	open a file to be archived. seek to the specified point. read the
	specified number of characters. close. exit. read one file or a segment
	of a file, writing the output to the archive. return the number of
	blocks written.
*/
	read_ifd = open(f_name,mode,0);
/**/
	if(read_ifd < 0)	{
		where(here);
		fprintf(stderr,"<open error> ");
		perror(f_name);
		return(-1);
		}
	if(lseek(read_ifd,begin,0) < 0L)	{
		where(here);
		fprintf(stderr,"<lseek error> ");
		perror(f_name);
		return(-1);
		}
/**/
#ifdef	DEBUG
	fprintf(stderr,"%s(%s,%ld,%ld)\n",here,f_name,begin,size);
#endif
/**/
	while(nci == nco && size >= 1)	{
/**/
/* PROBLEM: data conversion? */
		device.bif = (int) cal_bif(size);
		device.bif = device.bif >= NBUF ? NBUF : device.bif;
		nci = device.bif * BLKSIZ;
		nci = size >= nci ? nci : size;
/**/
#ifdef	DEBUG
	fprintf(stderr,"%s: size(%ld) device.bif(%u) nci(%u) device.wbc(%u)\n",
		here,size,device.bif,nci,device.wbc);
#endif
/**/
		nco = read(read_ifd,rbuf,nci);
/**/
		if(nco == 0)	{
			where(here);
			fprintf(stderr,"<unexpected eof> '%s'\n",f_name);
			}
		else
		if(nco != nci)	{
			where(here);
			fprintf(stderr,"<read error> ");
			perror(f_name);
			break;
			}
#ifdef	DEBUG
	fprintf(stderr,"%s: size(%ld) device.bif(%u) nci(%u) device.wbc(%u)\n",
		here,size,device.bif,nci,device.wbc);
#endif
/* PROBLEM: conflice in use of device.bif? */
/**/
		tar_place(rbuf,device.bif,here);
/**/
		blk += device.bif;
		size -= nco;
/**/
	}
	close(read_ifd);
/**/
	return(blk);
}
